package crawler;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import outputFormat.AmazonProduct;
import outputFormat.LVProduct;
import utility.ExcelManager;
import utility.SiteManager;
import java.util.Date;
import java.text.DateFormat;
import java.text.SimpleDateFormat;


public class AmazonCrawler {

	// file to write the output on
	private static String outputFile = "excelfile/amazon.xls";
	// site url
	private static String siteurl = "http://www.amazon.com";
	// gender of the product
	private static String gender;
	private static String category;
	// page to start crawl content

	// private static String menPerfume =
	// "http://www.amazon.com/s/qid=1219671933/ref=sr_nr_n_0?ie=UTF8&rs=11056591&keywords=perfume&bbn=11056761&rnid=11056591&rh=i%3Aaps%2Ck%3Aperfume%2Ci%3Abeauty%2Cn%3A3760911%2Cn%3A11056591%2Cn%3A11056761"
	// ;
	// private static String menPerfume =
	// "http://affiliate-program.amazon.com/gp/associates/network/build-links/individual/product-select.html/104-6743453-8184708?ie=UTF8&selectedSearchIndex=beauty&fieldKeywords=fragrance%20%20for%20women%20&page=2"
	// ;

	// private static String womenPerfume =
	// "http://www.amazon.com/s/qid=1219755477/ref=sr_nr_n_1?ie=UTF8&rs=11056591&keywords=perfume&bbn=11056931&rnid=11056591&rh=i%3Aaps%2Ck%3Aperfume%2Ci%3Abeauty%2Cn%3A3760911%2Cn%3A11056591%2Cn%3A11056931"
	// ;

	// EDP = Eau de parfum, EDT = Eau de toilettes
	private static String womenEDP = "http://www.amazon.com/s/qid=1219949441/ref=sr_st?rs=11057071&page=1&rh=n%3A3760911%2Cn%3A11056591%2Cn%3A11056931%2Cn%3A11057071&bbn=11057071&sort=salesrank";
	private static String womenEDT = "http://www.amazon.com/s/qid=1219949549/ref=sr_st?rs=11057081&page=1&rh=n%3A3760911%2Cn%3A11056591%2Cn%3A11056931%2Cn%3A11057081&bbn=11057081&sort=salesrank";

	private static String menEDT = "http://www.amazon.com/s/qid=1219949713/ref=sr_st?rs=363236011&page=1&rh=n%3A3760911%2Cn%3A11056591%2Cn%3A11056761%2Cn%3A363236011&bbn=363236011&sort=salesrank";
	private static String menAftershave = "http://www.amazon.com/s/qid=1219949866/ref=sr_st?rs=11059631&page=1&rh=n%3A3760911%2Cn%3A11056591%2Cn%3A11056761%2Cn%3A11059631&bbn=11059631&sort=salesrank";
	private static String menCologne = "http://www.amazon.com/s/qid=1219949966/ref=sr_st?rs=11059721&page=1&rh=n%3A3760911%2Cn%3A11056591%2Cn%3A11056761%2Cn%3A11059721&bbn=11059721&sort=salesrank";

	// private static String menEDP =
	// "http://www.amazon.com/s/qid=1219946374/ref=sr_nr_n_3?ie=UTF8&rs=11056761&sort=salesrank&bbn=363236011&rnid=11056761&rh=n%3A3760911%2Cn%3A11056591%2Cn%3A11056761%2Cn%3A363236011"
	// ;

	// crawled product counter
	private static int counter = 0;

	private static String priceUnit = "USD";
	// added by maoanz
	private static String quantity_unit = "ml";

	// image file save to fold
	private static String imgFold = "Amazon/";

	public static void main(String[] args) {
		AmazonProduct ap = new AmazonProduct();
		ExcelManager.prepareFile(outputFile, ap);
		
		String beginTime = getDateTime();
		System.out.println("Begin time: " + beginTime);
		
		/*gender = "Women";
		category = "Eau de Parfum";
		counter = 0;
		crawlContent(womenEDP, 1600);
		
		gender = "Women";
		category = "Eau de Toilette";
		counter = 0;
		crawlContent(womenEDT, 1700);

		 */
		
		
		
		gender = "Men";
		category = "Eau de Toilette";
		counter = 0;
		crawlContent(menEDT, 1500);

		
		gender = "Men";
		category = "Aftershave";
		counter = 0;
		crawlContent(menAftershave, 500);

		gender = "Men";
		category = "Cologne";
		counter = 0;
		crawlContent(menCologne, 320); 
		
		
		String endTime = getDateTime();
		
		System.out.println("Begin time: " + beginTime);
		System.out.println("End time: " + endTime);
		
	}

	// added by maoanz
	//convert the url to that contains the fashion2 tag
	private static String urlConvert(String url) {
		String productID = url.substring(url.lastIndexOf("/") + 1);
		String meta1 = "http://www.amazon.com/gp/product/";
		String meta2 = "/104-6743453-8184708?ie=UTF8&tag=wwwfashiono2c-20&linkCode=xm2&camp=1789&creativeASIN=";

		String res = meta1 + productID + meta2 + productID;
		return res;
	}

	// added by maoanz
	// to catch the quantity if the string contains the quantity
	private static String catchQuantity(String str) {

		Pattern quantityP = Pattern
				.compile("([0-9].[0-9]) ([o|O][z|Z]|Ounces|ounces|OUNCES)");
		Matcher quantityM = quantityP.matcher(str);

		if (quantityM.find()) {
			return quantityM.group(1);

		} else {
			return null;
		}
	}
	
	private static String oz2ml(String oz){
		if ( oz.equals("") ){
			return "";
		}
		double ozF;
		
		try {
			ozF= Double.parseDouble(oz);
		} catch (Exception e){
			System.out.println(e.toString());
			return oz+" oz";
		}
		
		double resF;
		
		if  (ozF == 1.0){
		    resF = 30.0;
		}else if (ozF == 1.7){
			resF = 50.0;			
		}else if (ozF == 3.4) {
			resF = 100.0;
		}else {
			resF = ozF * 29.57 ;			
		}
		
		Double resF2 = new Double(resF);
		
		Integer resInt = new Integer(resF2.intValue());
		String res= resInt.toString();
		return res;
	}
	
	//added by maoanz
	// to convert the image link the the defined prefix
	private static String imageURLConvert(String str, String prefix){
		String imageFileName = str.substring(str.lastIndexOf("/")+1);
		//String prefix = "etrend/perfume-image/";
		String res = prefix + imageFileName;
		return res;
	}
	
    private static String getDateTime() {
        DateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
        Date date = new Date();
        return dateFormat.format(date);
    }
	
	private static void crawlContent(String url, int stopCondition) {

		// save the page to a String
		String doc = SiteManager.getDocumentFromURL(url,
				"Baiduspider+(+http://www.baidu.com/search/spider.htm)");

		// find product links
		Pattern prodLinkNameP = Pattern
				.compile("<a href=\"([^\"]*?)\"><span class=\"srTitle\">([^<]*?)</span></a>");
		Matcher prodLinkNameM = prodLinkNameP.matcher(doc);

		while (prodLinkNameM.find()) {

			counter++;
			String link = prodLinkNameM.group(1);
			String name = prodLinkNameM.group(2);
			System.out
					.println("-------------------------------------------------------------------");
			System.out.println(counter + " product link: " + link);
			System.out.println("product name: " + name);
			crawlProduct(link, name);
			System.out
					.println("-------------------------------------------------------------------");

			if (counter > stopCondition - 1) {
				System.out.println("Stop condition matched!");
				return;
			}
		}

		// find next page to crawl
		Pattern nextPageP = Pattern
				.compile("<a href=\"([^\"]*?)\"([^>]*?)>Next([^>]*?)>");
		Matcher nextPageM = nextPageP.matcher(doc);
		if (nextPageM.find()) {
			String nextpage = siteurl + nextPageM.group(1);
			System.out
					.println("+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++");
			System.out.println("Next page to crawl products: " + nextpage);
			System.out
					.println("+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++");
			crawlContent(nextpage, stopCondition);
		}

	}



	private static void crawlProduct(String url, String name) {
		// save the page to a String
		String doc = SiteManager.getDocumentFromURL(url,
				"Baiduspider+(+http://www.baidu.com/search/spider.htm)");

		Pattern imageP = Pattern
				.compile("src=\"([^\"]*?)\" id=\"prodImage\" width=\"([^\"]*?)\" height=\"([^\"]*?)\"");
		Matcher imageM = imageP.matcher(doc);
		Pattern priceP = Pattern
				.compile("<b class=\"priceLarge\">([^<]*?)</b>");
		Matcher priceM = priceP.matcher(doc);

		Pattern descP = Pattern
				.compile("<b>Product Description</b><br />\n  ([^<]*?)<");
		Matcher descM = descP.matcher(doc);

		Pattern brandP = Pattern
				.compile("<span >\nOther products by ([^>]*?)>([^<]*?)</a>");
		Matcher brandM = brandP.matcher(doc);

		// added by maoanz
		String brand = "";
		String quantity = "";

		// write only the data with image and price to the sheet
		if (imageM.find() && priceM.find()) {
			String image = imageM.group(1);
			String price = priceM.group(1).substring(1);

			String desc = "";

			if (catchQuantity(name) == null) {
				// do nothing , quantity value is empty.
			} else {
				quantity = catchQuantity(name);
				quantity = oz2ml(quantity);		
			}

			if (brandM.find()) {
				brand = brandM.group(2);
			}

			System.out
					.println("+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++");
			System.out.println("Product image: " + image);
			try {
				image = SiteManager.saveImage(image, imgFold,
						AmazonProduct.idCount);
			} catch (Exception e) {
				e.printStackTrace();
			}

			System.out.println("Product price: " + price);
			System.out.println("Brand: " + brand);
			System.out.println("Quantity: " + quantity);
			
			if (descM.find()) {
				desc = descM.group(1);
				//desc = descM.group(0);
				//desc = desc.substring(0, desc.length() - 1).trim();
				System.out.println("Product description: " + desc);
			}
			System.out
					.println("+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++");

			//convert the url to that contains the fashion2 tag
			String url_modified = urlConvert(url);
			String imageLink_modified = imageURLConvert(image, "etrend/perfume-image/");
			AmazonProduct ap = new AmazonProduct(name, imageLink_modified, price, priceUnit,
					gender, desc, url_modified, brand, quantity, quantity_unit, category);
			ExcelManager.writeToFile(ap);
		}
	}
}
