package crawler;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import outputFormat.LVProduct;
import outputFormat.SwaroskiProduct;
import utility.ExcelManager;
import utility.SiteManager;

public class SwarovskiCrawler {
	// category pages
	private static String cate1 = "Collection Couture";
	private static String cate1type1page = "http://www.swarovski.com/category/Jewellery+%26+Accessories|Collection+Couture|Handbags/Web_AA/en?ProductPage=0&AllPages=yes";
	private static String cate1type1 = "Handbags";
	private static String cate1type2page = "http://www.swarovski.com/category/Jewellery+%26+Accessories|Collection+Couture|Jewellery/Web_AA/en?ProductPage=0&AllPages=yes";
	private static String cate1type2 = "Jewellery";
	private static String cate1type3page = "http://www.swarovski.com/category/Jewellery+%26+Accessories|Collection+Couture|Special+occasions/Web_AA/en";
	private static String cate1type3 = "Special occasions";
	
	private static String cate2 = "Jewellery";
	private static String cate2type1page = "http://www.swarovski.com/category/Jewellery+%26+Accessories|Jewellery|Bangles/Web_AA/en?ProductPage=0&AllPages=yes";
	private static String cate2type1 = "Bangles";
	private static String cate2type2page = "http://www.swarovski.com/category/Jewellery+%26+Accessories|Jewellery|Bracelets/Web_AA/en?ProductPage=0&AllPages=yes";
	private static String cate2type2 = "Bracelets";
	private static String cate2type3page = "http://www.swarovski.com/category/Jewellery+%26+Accessories|Jewellery|Brooches/Web_AA/en?ProductPage=0&AllPages=yes";
	private static String cate2type3 = "Brooches";
	private static String cate2type4page = "http://www.swarovski.com/category/Jewellery+%26+Accessories|Jewellery|Charms/Web_AA/en?ProductPage=0&AllPages=yes";
	private static String cate2type4 = "Charms";
	private static String cate2type5page = "http://www.swarovski.com/category/Jewellery+%26+Accessories|Jewellery|Clip+Earrings/Web_AA/en?ProductPage=0&AllPages=yes";
	private static String cate2type5 = "Clip Earrings";
	private static String cate2type6page = "http://www.swarovski.com/category/Jewellery+%26+Accessories|Jewellery|Cuff+Links/Web_AA/en";
	private static String cate2type6 = "Cuff Links";
	private static String cate2type7page = "http://www.swarovski.com/category/Jewellery+%26+Accessories|Jewellery|Hair+Jewels/Web_AA/en?ProductPage=0&AllPages=yes";
	private static String cate2type7 = "Hair Jewels";
	private static String cate2type8page = "http://www.swarovski.com/category/Jewellery+%26+Accessories|Jewellery|Necklaces/Web_AA/en?ProductPage=0&AllPages=yes";
	private static String cate2type8 = "Necklaces";
	private static String cate2type9page = "http://www.swarovski.com/category/Jewellery+%26+Accessories|Jewellery|Pendants/Web_AA/en?ProductPage=0&AllPages=yes";
	private static String cate2type9 = "Pendants";
	private static String cate2type10page = "http://www.swarovski.com/category/Jewellery+%26+Accessories|Jewellery|Pierced+Earrings/Web_AA/en?ProductPage=0&AllPages=yes";
	private static String cate2type10 = "Pierced Earrings";
	private static String cate2type11page = "http://www.swarovski.com/category/Jewellery+%26+Accessories|Jewellery|Pins/Web_AA/en?ProductPage=0&AllPages=yes";
	private static String cate2type11 = "Pins";
	private static String cate2type12page = "http://www.swarovski.com/category/Jewellery+%26+Accessories|Jewellery|Rings/Web_AA/en?ProductPage=0&AllPages=yes";
	private static String cate2type12 = "Rings";
	private static String cate2type13page = "http://www.swarovski.com/category/Jewellery+%26+Accessories|Jewellery|Sets/Web_AA/en";
	private static String cate2type13 = "Sets";
	
	private static String cate3 = "Bags & Accessories";
	private static String cate3type1page = "http://www.swarovski.com/category/Jewellery+%26+Accessories|Bags+%26+Accessories|Accessories/Web_AA/en?ProductPage=0&AllPages=yes";
	private static String cate3type1 = "Accessories";
	private static String cate3type2page = "http://www.swarovski.com/category/Jewellery+%26+Accessories|Bags+%26+Accessories|Active+Crystals/Web_AA/en?ProductPage=0&AllPages=yes";
	private static String cate3type2 = "Active Crystals";
	private static String cate3type3page = "http://www.swarovski.com/category/Jewellery+%26+Accessories|Bags+%26+Accessories|Belts/Web_AA/en";
	private static String cate3type3 = "Belts";
	private static String cate3type4page = "http://www.swarovski.com/category/Jewellery+%26+Accessories|Bags+%26+Accessories|Binoculars/Web_AA/en";
	private static String cate3type4 = "Binoculars";
	private static String cate3type5page = "http://www.swarovski.com/category/Jewellery+%26+Accessories|Bags+%26+Accessories|Handbags/Web_AA/en?ProductPage=0&AllPages=yes";
	private static String cate3type5 = "Handbags";
	private static String cate3type6page = "http://www.swarovski.com/category/Jewellery+%26+Accessories|Bags+%26+Accessories|Small+Leather+Goods/Web_AA/en?ProductPage=0&AllPages=yes";
	private static String cate3type6 = "mall Leather Goods";
	
	private static String cate4 = "Watches";
	private static String cate4type1page = "http://www.swarovski.com/category/Jewellery+%26+Accessories|Watches|Casual/Web_AA/en?ProductPage=0&AllPages=yes";
	private static String cate4type1 = "Casual";
	private static String cate4type2page = "http://www.swarovski.com/category/Jewellery+%26+Accessories|Watches|Classical/Web_AA/en?ProductPage=0&AllPages=yes";
	private static String cate4type2 = "Classical";
	private static String cate4type3page = "http://www.swarovski.com/category/Jewellery+%26+Accessories|Watches|Fashionable/Web_AA/en";
	private static String cate4type3 = "Fashionable";
	
	private static int count = 0;
	
	//file to write the output on
	private static String outputFile = "excelfile/swaroski.xls";
	//	image file save to fold
	private static String imgFold = "swarovski/";
	
	public static void main(String [] args){
		SwaroskiProduct sp = new SwaroskiProduct();
		ExcelManager.prepareFile(outputFile, sp);	
//		findProduct(cate1, cate1type1, cate1type1page);
//		findProduct(cate1, cate1type2, cate1type2page);
		findProduct(cate1, cate1type3, cate1type3page);
//		findProduct(cate2, cate2type1, cate2type1page);
//		findProduct(cate2, cate2type2, cate2type2page);
//		findProduct(cate2, cate2type3, cate2type3page);
//		findProduct(cate2, cate2type4, cate2type4page);
//		findProduct(cate2, cate2type5, cate2type5page);
//		findProduct(cate2, cate2type6, cate2type6page);
//		findProduct(cate2, cate2type7, cate2type7page);
//		findProduct(cate2, cate2type8, cate2type8page);
//		findProduct(cate2, cate2type9, cate2type9page);
//		findProduct(cate2, cate2type10, cate2type10page);
//		findProduct(cate2, cate2type11, cate2type11page);
		findProduct(cate2, cate2type12, cate2type12page);
//		findProduct(cate2, cate2type13, cate2type13page);
//		findProduct(cate3, cate3type1, cate3type1page);
//		findProduct(cate3, cate3type2, cate3type2page);
//		findProduct(cate3, cate3type3, cate3type3page);
//		findProduct(cate3, cate3type4, cate3type4page);
//		findProduct(cate3, cate3type5, cate3type5page);
//		findProduct(cate3, cate3type6, cate3type6page);
//		findProduct(cate4, cate4type1, cate4type1page);
//		findProduct(cate4, cate4type2, cate4type2page);
//		findProduct(cate4, cate4type3, cate4type3page);
	}
	private static void findProduct(String category, String type, String url) {
		//save the page to a String
		String doc = SiteManager.getDocumentFromURL(url, "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)");
		System.out.println("-------------------------------------------------------------------");
		System.out.println("-------------------------------------------------------------------");
		System.out.println("-------------------------------------------------------------------");
		System.out.println("Category: "+category+" type: "+type+" url: "+url);
		System.out.println("-------------------------------------------------------------------");
		System.out.println("-------------------------------------------------------------------");
		System.out.println("-------------------------------------------------------------------");
		//find product link
		Pattern productP = Pattern.compile("<a id=\"([^\"]*?)\" href=\"([^\"]*?)\" title=\"([^\"]*?)\" class=\"Rot1C\">([^<]*?)</a>");
		Matcher productM = productP.matcher(doc);
		while(productM.find()){
			String prodName = productM.group(4);
			String prodLink = productM.group(2);
			System.out.println("-------------------------------------------------------------------");
			System.out.println(count+" Product: "+prodName+" link: "+prodLink);
			crawlContent(category, type, prodName, prodLink);
			System.out.println("-------------------------------------------------------------------");
			count++;
		}
	}
	private static void crawlContent(String category, String type, String prodName, String prodLink) {
		//save the page to a String
		String doc = SiteManager.getDocumentFromURL(prodLink, "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)");
//		System.out.println(doc);
		Pattern descP = Pattern.compile("</h1>(\\s*?)<p>([^<]*?)</p>(\\s*?)<!-- Anfang: \"DETAILInfokern\" -->(\\s*?)" +
				"<div id=\"DETAILInfokern\">(\\s*?)<p class=\"Detail\">(\\s*?)Article no.:(\\s*?)<span id=\"text_artikelnummer\">" +
				"([^<]*?)</span>(\\s*?)</p>(\\s*?)<p class=\"Detail\">([^<]*?)</p>");
		Matcher descM = descP.matcher(doc);
		Pattern priceP = Pattern.compile("<strong class=\"Preis\" id=\"text_preis\">(\\s*?)EUR([^<]*?)</strong>");
		Matcher priceM = priceP.matcher(doc);
		Pattern imageP = Pattern.compile("<img src=\"([^\"]*?)\" width=\"240\" height=\"240\" alt=\"([^\"]*?)\" border=\"0\" class=\"Produktabbildung\">");
		Matcher imageM = imageP.matcher(doc);
		while(descM.find() && priceM.find() && imageM.find()){
			String desc = descM.group(2);
			desc += descM.group(11);
			String price = priceM.group(2);
			String image = "http://www.swarovski.com/"+imageM.group(1);
			try {
				image = SiteManager.saveImage(image, imgFold, SwaroskiProduct.idCount);
			} catch (Exception e) {
				e.printStackTrace();
			}
			System.out.println("prod desc: "+desc);
			System.out.println("prod price: "+price);
			System.out.println("image: "+image);
			SwaroskiProduct sp = new SwaroskiProduct(prodName, image, "Swaroski", price, "EUR", desc, category, type, prodLink);
			ExcelManager.writeToFile(sp);
		}
	}
}
